# Licensed Materials - Property of IBM                       
# Component IBM Rational ROSE_RT BUILD : TARGET_RTS                 
# Copyright IBM Corporation 1999, 2008. All Rights Reserved.      
# U.S. Government Users Restricted Rights -  Use, duplication or    
# disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.



if( $OS_HOME = $ENV{'OS_HOME'} )
{
    $os = $ENV{'OS'} || 'unknown';

    if( $os eq 'Windows_NT' )
    {
	$LYNX_310_ROOT = "$OS_HOME/Lynx/3.1.0/WinNT-ppc/usr/lynx/3.1.0/ppc";
	$HOST_OS       = 'win32';
	$DLL           = "$OS_HOME/Lynx/3.1.0/WinNT-ppc/usr/bin;";
	$ps            = ';';
    }
    else
    {
	$os = `uname -sr`;

	if( $os =~ m{^SunOS 5\.} )
	{
	    $LYNX_310_ROOT = "$OS_HOME/Lynx/3.1.0/Solaris-ppc";
	    $HOST_OS       = 'sunos';
	}
	elsif( $os =~ m{^LynxOS 3\.1\.} )
	{
	    $LYNX_310_ROOT = '';
	}
	else
	{
	    print STDERR "'$os' is not a supported host.\n";
	    exit 1;
	}

	$DLL = '';
	$ps  = ':';
    }

    $DEV = "$LYNX_310_ROOT/cdk/$HOST_OS-xcoff-ppc";
    $LIB = "$DEV/usr/lib/gcc-lib/ppc-xcoff-lynxos/2.9-gnupro-98r2";

    $ENV{'PATH'}            = "$DEV/usr/bin$ps$DLL$LIB$ps$ENV{'PATH'}";
    $ENV{'LIBRARY_PATH'}    = "$LYNX_310_ROOT/lib";
    $ENV{'GCC_EXEC_PREFIX'} = "$LYNX_310_ROOT/lib/";
    $ENV{'LYNX_310_INC'}    = "$LYNX_310_ROOT/usr/include";
    $ENV{'ENV_PREFIX'}      = $LYNX_310_ROOT;
}

$preprocessor = "g++ -DPRAGMA -E -P >MANIFEST.i";
$target_base  = 'LYNX2';
$supported    = 'Yes';
