/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTMessageQ_inl__
#define __RTMessageQ_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTMessage_h__
#include <RTMessage.h>
#endif

#ifndef __RTMessageQ_h__
#include <RTMessageQ.h>
#endif

RTS_INLINE void RTMessageQ::appendFrom( RTMessageQ & other )
{
    if( head == (RTMessage *)0 ) // queue is empty
	head = other.head;
    else
	tail->next = other.head;

    tail = other.tail;

    other.head = (RTMessage *)0;
    other.tail = (RTMessage *)0;
}

RTS_INLINE int RTMessageQ::isEmpty( void ) const
{
    return head == (RTMessage *)0;
}

RTS_INLINE void RTMessageQ::nqTail( RTMessage * msg )
{
    if( tail == (RTMessage *)0 ) // queue is empty
	head = msg;
    else
	tail->next = msg; // add to end

    tail = msg;
    msg->next = (RTMessage *)0;
}

RTS_INLINE RTMessage * RTMessageQ::dqHead( void )
{
    RTMessage * msg = head;

    if( msg != (RTMessage *)0 ) // queue is not empty
    {
	if( (head = msg->next) == (RTMessage *)0 )
	    tail = (RTMessage *)0;
	msg->next = (RTMessage *)0;
    }

    return msg;
}

RTS_INLINE RTMessage * RTMessageQ::dqAll( void )
{
    RTMessage * msg = head;

    head = tail = (RTMessage *)0;

    return msg;
}

#endif // __RTMessageQ_inl__
