/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTPointer_h__
#define __RTPointer_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTByteBlock_h__
#include <RTByteBlock.h>
#endif

class RTPointer : public RTByteBlock
{
public:
    explicit                RTPointer( void * value = (void *)0 );
			    RTPointer( const RTPointer & );
    virtual                 ~RTPointer( void );

    RTPointer             & operator=( void * );
    RTPointer             & operator=( const RTPointer & );

    virtual int             operator==( const RTDataObject & ) const;

    virtual const RTObject_class * getClassData( void ) const;
    static  const RTObject_class   classData;

#define RTType_RTPointer ( RTPointer::classData )
};

struct RTTypedValue_RTPointer
{
    const void           * data;
    const RTObject_class * type;

    RTS_INLINE RTTypedValue_RTPointer( const RTPointer      & ); //lint !e1931
    RTS_INLINE RTTypedValue_RTPointer( const RTPointer      &,
				       const RTObject_class * );
}; //lint !e1712

#if RTS_INLINES
#include <RTPointer.inl>
#endif

#endif // __RTPointer_h__
