/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTResourceMgr_h__
#define __RTResourceMgr_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

class  RTMessage;
struct RTMessageBlock;
#if USE_THREADS
class  RTMutex;
#endif

class RTResourceMgr
{
protected:
    RTMessage         * messages;
    RTMessageBlock    * blocks;
#if USE_THREADS
    RTMutex           * access;
#endif

public:
		RTResourceMgr( void );
		~RTResourceMgr( void );

    unsigned    msgAlloc( RTMessage * &, unsigned howMany = 50U );
    void        msgFree ( RTMessage * &, unsigned howMany =  0U );

private:
    // unavailable methods
    RTResourceMgr( const RTResourceMgr & );
    RTResourceMgr & operator=( const RTResourceMgr & );
};

#endif // __RTResourceMgr_h__
