/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTTimerId_inl__
#define __RTTimerId_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTTimerId_h__
#include <RTTimerId.h>
#endif

RTS_INLINE RTTimerId::Ring::Ring( void )
#ifdef _lint
    : prev( (Ring *)0 )
    , next( (Ring *)0 )
#endif
{
    prev = this;
    next = this;
}

RTS_INLINE RTTimerId::RTTimerId( void )
    : ring(                  )
    , node( (RTTimerNode *)0 )
{
}

RTS_INLINE RTTimerId::RTTimerId( const RTTimerId & id )
    : ring(                  )
    , node( (RTTimerNode *)0 )
{
    *this = id;
}

RTS_INLINE RTTimerId::RTTimerId( RTTimerNode * n )
    : ring(                  )
    , node( (RTTimerNode *)0 )
{
    if( n != (RTTimerNode *)0 )
	*this = n;
}

RTS_INLINE int RTTimerId::operator==( const RTTimerId & rhs ) const
{
    return rhs.node == node;
}

RTS_INLINE int RTTimerId::operator!=( const RTTimerId & rhs ) const
{
    return rhs.node != node;
}

RTS_INLINE int RTTimerId::isValid( void ) const
{
    return node != (RTTimerNode *)0;
}

RTS_INLINE
RTTypedValue_RTTimerId::
RTTypedValue_RTTimerId( const RTTimerId & _value )
    : data( &_value )
    , type( &RTType_RTTimerId )
{
}

RTS_INLINE
RTTypedValue_RTTimerId::
RTTypedValue_RTTimerId( const RTTimerId      & _value,
			const RTObject_class * _type )
    : data( &_value )
    , type( _type   )
{
}

#endif // __RTTimerId_inl__
