# Licensed Materials - Property of IBM                       
# Component IBM Rational ROSE_RT BUILD : TARGET_RTS                 
# Copyright IBM Corporation 1999, 2008. All Rights Reserved.      
# U.S. Government Users Restricted Rights -  Use, duplication or    
# disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.



# ======== General Defaults ==============================================

CONFIG = $(TARGET).$(LIBRARY_SET)

# Defaults for macros which may be modified by
#    libset/$(LIBRARY_SET)/libset.mk
#    target/$(TARGET)/target.mk
# or config/$(CONFIG)/config.mk

PERL          = rtperl
FEEDBACK      = $(PERL) "$(RTS_HOME)/tools/feedback.pl"
MERGE         = $(PERL) "$(RTS_HOME)/tools/merge.pl"
NOP           = $(PERL) "$(RTS_HOME)/tools/nop.pl"
RM            = $(PERL) "$(RTS_HOME)/tools/rm.pl"
RMF           = $(RM) -f
TOUCH         = $(PERL) "$(RTS_HOME)/tools/touch.pl"

# codegen makefiles stuff

RTGEN         = rtcppgen
RTCOMP        = $(PERL) "$(RTS_HOME)/codegen/rtcomp.pl"
RTLINK        = $(PERL) "$(RTS_HOME)/codegen/rtlink.pl"
VENDOR        = generic

# Macros used when make must recurse

MAKEFILE      = Makefile

# Macros used when creating an object file from a C++ source file

CC            = $(FEEDBACK) -fail \
		    CC should be defined by libset.mk or generated makefile
DEBUG_TAG     = -g
DEPEND_TAG    = -I
DEFINE_TAG    = -D
INCLUDE_TAG   = -I
LIBSETCCEXTRA =
LIBSETCCFLAGS =
OBJECT_OPT    = -c
OBJOUT_OPT    = -o
OBJOUT_TAG    =
SHLIBCCFLAGS  = -PIC
TARGETCCFLAGS =

# Macros used when creating an object library from a set of object files

AR_CMD        = $(PERL) "$(RTS_HOME)/tools/ar.pl"
AR            = $(AR_CMD)
LIBOUT_OPT    =
LIBOUT_TAG    =

# Macros used when creating an shared library from a set of object files

SHLIB_CMD     = $(FEEDBACK) -fail Shared libraries not supported.
SHLIBOUT_OPT  = -o
SHLIBOUT_TAG  =

# Macros used when creating an executable from a set of object files, libraries

LD            = $(CC)
DIR_TAG       = -L
LIBSETLDFLAGS =
LIB_TAG       = -l
OT_LIB_TAG    = -l
TARGETLDFLAGS =
TARGETLIBS    =
EXEOUT_OPT    = -o
EXEOUT_TAG    =

# Macros used to construct names of various kinds of files

EXEC_EXT      =
LIB_PFX       = lib
LIB_EXT       = .a
CPP_EXT       = .cc
OBJ_EXT       = .o
SHLIB_PFX     = lib
SHLIB_EXT     = .so

# ========= Shared Macros ================================================

RTSYSTEM_INCPATHS = \
	$(INCLUDE_TAG)"$(RTS_HOME)/libset/$(LIBRARY_SET)" \
	$(INCLUDE_TAG)"$(RTS_HOME)/target/$(TARGET)" \
	$(INCLUDE_TAG)"$(RTS_HOME)/include"

RTS_LIBRARY   = $(RTS_HOME)/lib/$(CONFIG)

SYSTEM_LIBS   = $(DIR_TAG)"$(RTS_LIBRARY)" \
		$(OT_LIB_TAG)ObjecTime \
		$(OT_LIB_TAG)ObjecTimeTypes

# ========= Linking ======================================================

LD_OUT = $@

LD_HEAD = \
	$(EXEOUT_OPT) $(EXEOUT_TAG)$(LD_OUT) \
	$(LIBSETLDFLAGS) \
	"$(RTS_LIBRARY)/main$(OBJ_EXT)"

ALL_OBJS_LIST = $(ALL_OBJS)

LD_TAIL = \
	$(SYSTEM_LIBS) \
	$(TARGETLDFLAGS) \
	$(TARGETLIBS)

# ======== Compiling =====================================================

CC_HEAD = \
	$(OBJECT_OPT) $(OBJOUT_OPT) $(OBJOUT_TAG)$@ \
	$(LIBSETCCFLAGS) \
	$(TARGETCCFLAGS) \
	$(RTSYSTEM_INCPATHS)

CC_TAIL =

# ========================================================================
