/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActor.h>
#include <RTDiag.h>

#if OBSERVABLE
#include <RTActorProbe.h>
#endif

void RTActor::enterState( int s )
{
    int c = getCurrentState();

    RTAssert( s != c );

#if RTStateId_MaxSize == 1
    state->history.s1[ c - 1 ] = (unsigned char)s;
#else
    switch( state->idShift )
    {
    default:
#if RTStateId_MaxSize > 2
	state->history.s4[ c - 1 ] = (unsigned)s;
	break;
    case 1:
#endif
	state->history.s2[ c - 1 ] = (unsigned short)s;
	break;
    case 0:
	state->history.s1[ c - 1 ] = (unsigned char)s;
	break;
    }
#endif

    setCurrentState( s );

    enterStateV();

#if OBSERVABLE
    if( probe != (RTActorProbe *)0 )
	probe->evtChain( 0 );
#endif
}
