/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActor.h>
#include <RTSpecialPorts.h>
#include <RTSpecialSignals.h>

void RTActor::processHistory( void )
{
    for(;;)
    {
	int s = getCurrentState();
	int h = getHistory( s );

	if( h == s ) // state was already initialized
	    break;

	if( h != 0 )
	    enterState( h );
	else
	{
#if RTStateId_MaxSize == 1
	    state->history.s1[ s - 1 ] = (unsigned char)s;
#else
	    switch( state->idShift )
	    {
	    default:
#if RTStateId_MaxSize > 2
		state->history.s4[ s - 1 ] = (unsigned)s;
		break;
	    case 1:
#endif
		state->history.s2[ s - 1 ] = (unsigned short)s;
		break;
	    case 0:
		state->history.s1[ s - 1 ] = (unsigned char)s;
		break;
	    }
#endif

	    // initialize state s
	    rtsBehavior( RTInitSignal, RTControlPort );
	}
    }
}
