/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActor.h>
#include <RTActorRef.h>
#include <RTImportList.h>

void RTActor::removeAllImports( RTController * initiator )
{
	


#if USE_THREADS
    RTActorRef::lock();
#endif

    RTImportList * list;
    for( list = importList; list != (RTImportList *)0; list = list->used.next )
	_unbind( list->used.reference ,initiator);
    list = importList;

    importList = (RTImportList *)0;

#if USE_THREADS
    RTActorRef::unlock();
#endif

    while( list != (RTImportList *)0 )
    {
	RTImportList * next = list->used.next;

	(void)list->used.reference->deport( this, list,initiator );

	list = next;
    }
}
