/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTAsciiEncoding.h>
#include <RTFieldDescriptor.h>
#include <RTObject_class.h>

int RTAsciiEncoding::putFields( const void           * value,
				const RTObject_class * record,
				int                  & first )
{
    if( record->_super == (const RTObject_class *)0 )
    {
	// we have no base type
    }
    else
    {
	if( putFields( (*record->_super_accessor)( RTConstCast( void, value ) ),
		       record->_super,
		       first ) == 0 )
	    return 0; // failure encoding the base type
    }

    int                       count = record->_num_fields;
    const RTFieldDescriptor * field = record->_fields;

    for( ; --count >= 0; ++field )
    {
	if( field->type == (const RTObject_class *)0 )
	    continue; // skip fields of unknown types

	if( first != 0 )
	    first = 0;
	else if( putFieldSeparator() == 0 )
	    return 0;

	if( putName( field->name ) == 0 )
	    return 0;

	if( field->encode( value, this ) == 0 )
	    return 0;
    }

    return 1;
}
