/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */


#include <RTCmdLineObserver.h>
#include <RTDaemon.h>
#include <RTMemoryUtil.h>
#include <RTVersion.h>

//lint -save -e786
static const char * const banner[] =
{
    "Rational Rose RealTime C++ Target Run Time System\r\n",
    RT_VERSION_STRING, "\r\n",
    "Copyright (c) 1999-" RT_VERSION_YEAR " Rational Software\r\n",
    "\r\n",
    "*****************************************************\r\n",
    "* Please note: The output from any command you type *\r\n",
    "*   here will be sent to the executable's STDOUT.   *\r\n",
    "*****************************************************\r\n",
    (const char *)0
};
//lint -restore

RTCmdLineObserver::RTCmdLineObserver( RTDebugger  * theDebugger,
				      RTTcpSocket * theSocket,
				      int           theObsId,
				      const char  * initBuf,
				      int           initLen )
    : RTObserver( theDebugger, theSocket, theObsId, initBuf, initLen )
{
    for( const char * const * line = banner; *line != (const char *)0; ++line )
	(void)sendData( *line, RTMemoryUtil::strlen( *line ) );

    cmdCreateDaemon( 0 );
    (void)setDaemon( 0 );
    daemon->updateSettings( "type=Command;" );
}
