/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActor.h>
#include <RTController.h>
#include <RTDebugger.h>
#include <RTEventInfo.h>

void RTController::breakPoint( RTActor * actor, RTEventInfo * eventInfo )
{
    // Save the active message. The actor might be the target of
    // a RTFieldSignal message if it stops at this break point.

    const RTMessage * msg = actor->msg;

    actor->msg = (const RTMessage *)0;

    eventInfo->actor = actor;
    eventInfo->info  = actor->getActorData();

    int shouldHalt = debugger()->breakPoint( this, eventInfo );

    if( shouldHalt > 0 )
	while( debugger()->step_begin( this ) == 0 )
	    awaitResponse();

    actor->msg = msg; // restore the message
}
