/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActor.h>
#include <RTController.h>
#if USE_THREADS
#include <RTMutex.h>
#endif
#include <RTQFilter.h>

void RTController::filterMessages( RTActor * receiver, RTQFilter & filter )
{
    short        bits;
    short        priority;
    short        priorityBit;
    RTMessageQ * queue;

#if USE_THREADS
    if( incomingBits != 0 )
	acceptIncoming();
#endif

    // filter messages in internal queues.
    for( bits = internalBits; bits != 0; )
    {
	priority    = topPriority[ bits ];
	priorityBit = (short)( 1 << priority );
	queue       = &internalQ[ priority ];

	if( queue->filterAll( filter ) != 0 && queue->isEmpty() != 0 )
	    internalBits ^= priorityBit;

	bits ^= priorityBit;
    }

    // filter messages in the deferred queue
#if DEFER_IN_ACTOR
    (void)receiver->deferredQ.filterAll( filter );
#else
    (void)receiver;
    (void)          deferredQ.filterAll( filter );
#endif
}
