/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTController.h>

const char * RTController::strerror( void ) const
{
    switch( errorNumber )
    {
      case ok:
	return "No error.";
      case alreadyDeferred:
	return "Message already deferred.";
      case badActor:
	return "Invalid actor id.";
      case badClass:
	return "Not a compatible subclass.";
      case badId:
	return "Invalid timer id.";
      case badIndex:
	return "Invalid replication index.";
      case badInterface:
	return "Non-existent interface.";
      case badOperation:
	return "Operation not permitted.";
      case badRef:
	return "Reference not a member of this actor.";
      case badSignal:
	return "Invalid signal.";
      case badValue:
	return "Invalid argument.";
      case deferInvoke:
	return "Defer of invoked message.";
      case dereg:
	return "Not registered.";
      case imported:
	return "Reference is imported.";
      case noConnect:
	return "Port not connected.";
      case noMem:
	return "Out of memory.";
      case noReply:
	return "No reply to invoke.";
      case notImported:
	return "Reference must be imported.";
      case notOptional:
	return "Reference must be optional.";
      case notOwner:
	return "Permission denied.";
      case prio:
	return "Bad priority.";
      case protocolSignal:
	return "Incompatible protocol (signal mismatch).";
      case protocolType:
	return "Incompatible protocol (type mismatch).";
      case recursiveInvoke:
	return "Recursive invoke.";
      case refFull:
	return "Reference full.";
      case reg:
	return "Registration failed.";
      case replRef:
	return "The replication factor of the reference exceeds 1.";
      case smallInterface:
	return "Insufficient interface replication.";
      case tooManySAPs:
	return "Number of SAPs exceeds rep factor of SPP.";
      case xRtsInvoke:
	return "Invoke crosses controller boundary.";
      default:
	return "Invalid errorNumber.";
    }
}
