/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActor.h>
#include <RTController.h>
#include <RTDebugger.h>
#include <RTMessage.h>
#include <RTProtocol.h>

int RTDebugger::doInject( RTProtocol           * port,
			  int                    index,
			  int                    signal,
			  int                    prio,
			  const void           * data,
			  const RTObject_class * type )
{
    RTActor      * actor    = port->getOwner();
    RTController * receiver = actor->context();
    RTMessage    * destMsg  = newMsg();

    if( destMsg == (RTMessage *)0 )
    {
	receiver->setError( RTController::noMem,
			    RTController::SystemService,
			    (const void *)0,
			    (const void *)0 );
	return 0;
    }

    destMsg->setData( data, type );
    destMsg->setSignal( signal );
    destMsg->setPriority( prio );
    destMsg->setDestination( actor, port, index );
    destMsg->internData();

#if USE_THREADS
    receiver->peer_receive( destMsg );
#else
    receiver->receive( destMsg, (RTController *)0 );
#endif

    return 1;
}
