/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDebugger.h>
#include <RTEventInfo.h>

void RTDebugger::evtRtsStatus( int observerId )
{
    RTEventInfo * eventInfo = new RTEventInfo( RTEventInfo::EventControl,
					       -1,
					       -1 );

    if( observerId < 0 ) // invalid observer Id: event (otherwise request)
	getTimestamp( eventInfo->timestamp );

    eventInfo->observerId = observerId;

    switch( mode )
    {
    case Halted:   eventInfo->targetMode = RTEventInfo::Halted;   break;
    case Stepping: eventInfo->targetMode = RTEventInfo::Stepping; break;
    case Running:  eventInfo->targetMode = RTEventInfo::Running;  break;
    }

    (void)addEvent( eventInfo );
}
