/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDebugger.h>
#if USE_THREADS
#include <RTMutex.h>
#endif
#include <RTProbe.h>

void RTDebugger::probeCreated( int probeId, RTProbe * probe )
{
#if USE_THREADS
    _mutex->enter();
#endif

    probes[ probeId ] = (void *)probe;
    if( probe->connectProbe() == 0 )
    {
	parkedProbes[ parkedProbes.unusedIndex() ] = (void *)probe;
	++nrParkedProbes;
    }

#if USE_THREADS
    _mutex->leave();
#endif
}
