/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActor.h>
#include <RTController.h>
#include <RTDebugger.h>
#include <RTMessage.h>
#include <RTSpecialSignals.h>

void RTDebugger::sendProbeSignal( RTActor * actor, int priority )
{
    if( actor == (RTActor *)0 )
	return;

    RTController * receiver = actor->context();
    RTMessage    * destMsg  = newMsg();

    if( destMsg == (RTMessage *)0 )
    {
	receiver->setError( RTController::noMem,
			    RTController::SystemService,
			    (const void *)0,
			    (const void *)0 );
    }
    else
    {
	destMsg->setData( (const void *)0, (const RTObject_class *)0 );
	destMsg->setSignal( RTProbeSignal );
	destMsg->setPriority( priority );
	destMsg->setDestination( actor, (RTProtocol *)0, 0 );

#if USE_THREADS
	receiver->peer_receive( destMsg );
#else
	receiver->receive( destMsg, (RTController *)0 );
#endif
    }
}
