/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActor.h>
#include <RTActorProbe.h>
#include <RTDebugger.h>
#include <RTMessage.h>
#if USE_THREADS
#include <RTMutex.h>
#endif
#include <RTProtocol.h>

void RTDebugger::setTimestamp( RTMessage        * msg,
			       const RTProtocol * source,
			       int                sourceIndex )
{
    if( msg == (RTMessage *)0 )
	return; // no message

    if( source != (const RTProtocol *)0 )
    {
	RTActor * sender = source->getOwner();

	if( sender != (RTActor *)0 && sender->probe != (RTActorProbe *)0 )
	{
	    msg->_sendProbeId   = sender->probe->getProbeId();
	    msg->_sendPortId    = source->getId();
	    msg->_sendPortIndex = sourceIndex;

#if USE_THREADS
	    _mutex->enter();
#endif

	    getTimestamp( msg->_sendTime );

#if USE_THREADS
	    _mutex->leave();
#endif

	    return;
	}
    }

    RTActor * receiver = msg->receiver();

    if( receiver != (RTActor *)0 && receiver->probe != (RTActorProbe *)0 )
    {

#if USE_THREADS
	_mutex->enter();
#endif

	getTimestamp( msg->_sendTime );

#if USE_THREADS
	_mutex->leave();
#endif
    }
}
