/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDebugger.h>
#include <RTEventInfo.h>
#include <RTObserver.h>
#if USE_THREADS
#include <RTMutex.h>
#endif

int RTDebugger::useEvent( void )
{
    int result = 0;

#if USE_THREADS
    _mutex->enter();
#endif

    RTEventInfo * eventInfo;

    if( (eventInfo = eventTail) != (RTEventInfo *)0 ) // get last in list
    {
	result = 1;

	if( eventTail->prev != (RTEventInfo *)0 )     // > 1 event in list
	    eventTail->prev->next = (RTEventInfo *)0;
	else
	    eventHead = (RTEventInfo *)0;

	eventTail       = eventTail->prev;
	eventInfo->prev = (RTEventInfo *)0;

	dispatchEvent( eventInfo );
	delete eventInfo;
    }

#if USE_THREADS
    _mutex->leave();
#endif

    return result;
}
