/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTFloat.h>

//lint -save -e922

double RTFloat::value( void )
{
    const double scale  = (double)word_scale;
    double       result = (double)mantissa[ mantissa_words - 1 ];

    for( int i = mantissa_words - 1; --i >= 0; )
    {
	result /= scale;
	result += (double)mantissa[ i ];
    }

    int exponent = exp_2 + mantissa_bits - bits_per_word;

    if( exponent < 0 )
    {
	// The magnitude of the exponent can create unwanted
	// overflow problems with very small values.
	// To avoid this situation we divide in two steps.

	unsigned magnitude = (unsigned)- exponent;

	result /= pow2( ( magnitude + 0U ) >> 1 );
	result /= pow2( ( magnitude + 1U ) >> 1 );
    }
    else if( exponent > 0 )
	result *= pow2( (unsigned)exponent );

    return result;
}

//lint -restore
