/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActor.h>
#include <RTActorId.h>
#include <RTActorRef.h>
#include <RTController.h>
#include <RTFrame.h>

int Frame::Base::destroy( RTActorId & actorid )
{
    RTController * controller = context();
    RTActor      * actor      = actorid.getRTActor();

    if( actor == (RTActor *)0 )
    {
	controller->trace( RTController::FrameDestroy, (const void *)0,
						       (const void *)0 );

	controller->setError( RTController::badActor,
			      RTController::FrameDestroy, (const void *)0,
							  (const void *)0 );
    }
    else
    {
	RTActorRef * reference = actor->getReference();

	controller->trace( RTController::FrameDestroy, reference,
						       (const void *)0 );

	if( reference->isOptional() == 0 )
	{
	    controller->setError( RTController::notOptional,
				  RTController::FrameDestroy, reference,
							      (const void *)0 );
	}
#if RTFRAME_CHECKING != RTFRAME_CHECK_NONE
	else if( permissionCheck( RTController::FrameDestroy,
				  reference, 0 ) == 0 )
	{
	    // not allowed
	}
#endif
	else
	{
	    actorid.resetActor();
	    return reference->destroy( actor );
	}
    }

    return 0;
}
