/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTInterval.h>

RTInterval::RTInterval( void )
    : sec ( 0L )
    , usec( 0L )
{
}

RTInterval::RTInterval( unsigned long centiseconds )
    : sec ( (long)( centiseconds / 100UL )          )
    , usec( (long)( centiseconds % 100UL ) * 10000L )
{
}

RTInterval::RTInterval( long s, long us )
    : sec ( s  )
    , usec( us )
{
}

RTInterval::RTInterval( const RTInterval & other )
    : sec ( other.sec  )
    , usec( other.usec )
{
}
