/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTAssociation.h>
#include <RTDictionary.h>
#include <RTLayerConnector.h>
#include <RTQueue.h>

void RTLayerConnector::cleanup( void )
{
    RTDictionary::Iterator   i;
    const RTAssociation    * assoc;

    lock();

    while( (assoc = pendingSAPs.iterate( i )) != (const RTAssociation *)0 )
	delete (RTQueue *)assoc->value;

    i.reset();

    while( (assoc = pendingSPPs.iterate( i )) != (const RTAssociation *)0 )
	delete (RTQueue *)assoc->value;

    unlock();
}
