/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTLocalConnector.h>
#include <RTProtocol.h>

void RTLocalConnector::SppNode::deregister( RTController * context )
{
    RTLocalConnector::unbind( context, *spp );

    SapNode * entry = saps;

    if( entry == (SapNode *)0 )
    {
		(void)connector->db.remove( parseName( name ) );
		delete this;
    }
    else
    {
		spp = (RTProtocol *)0;

		do
		{
			Request * request = &entry->initial;
			int       start   = 0;

			do
			{
			request->start = start;
			start = request->limit;
			}
			while( (request = request->chain) != (Request *)0 );
		}
		while( (entry = entry->next) != saps );

	    pending = requests;
    }

}
