/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTObject_class.h>

static void long_init( const RTObject_class *, void * target )
{
    *(long *)target = 0L;
}

static void long_copy( const RTObject_class *,
		       void                 * target,
		       const void           * source )
{
    *(long *)target = *(const long *)source;
}

#if OBJECT_DECODE
static int long_decode( const RTObject_class *,
			void                 * target,
			RTDecoding           * coding )
{
    return coding->get_long( *(long *)target );
}
#endif

#if OBJECT_ENCODE
static int long_encode( const RTObject_class *,
			const void           * source,
			RTEncoding           * coding )
{
    return coding->put_long( *(const long *)source );
}
#endif

const RTObject_class RTType_long =
{
    (RTObject_class *)0,
    (RTSuperAccessFunction)0,
    "long",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( long ),
    long_init,
    long_copy,
#if OBJECT_DECODE
    long_decode,
#endif
#if OBJECT_ENCODE
    long_encode,
#endif
    RTnop_destroy,
    0, (const RTFieldDescriptor *)0
};

#if OBJECT_DECODE
RTTypeInstaller long_installer( RTType_long );
#endif
