/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTObject_class.h>

static void pvoid_init( const RTObject_class *, void * target )
{
    *(void **)target = (void *)0;
}

static void pvoid_copy( const RTObject_class *,
			void                 * target,
			const void           * source )
{
    *(void **)target = *(void * const *)source;
}

#if OBJECT_DECODE
static int pvoid_decode( const RTObject_class *,
			 void                 * target,
			 RTDecoding           * coding )
{
    return coding->get_address( *(void **)target );
}
#endif

#if OBJECT_ENCODE
static int pvoid_encode( const RTObject_class *,
			 const void           * source,
			 RTEncoding           * coding )
{
    return coding->put_address( *(void * const *)source );
}
#endif

const RTObject_class RTType_RTpvoid =
{
    (const RTObject_class *)0,
    (RTSuperAccessFunction)0,
    "RTpvoid",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( void * ),
    pvoid_init,
    pvoid_copy,
#if OBJECT_DECODE
    pvoid_decode,
#endif
#if OBJECT_ENCODE
    pvoid_encode,
#endif
    RTnop_destroy,
    0, (const RTFieldDescriptor *)0
};

#if OBJECT_DECODE
RTTypeInstaller RTpvoid_installer( RTType_RTpvoid );
#endif
