/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTPortDescriptor.h>
#include <RTProtocol.h>
#include <RTProtocolDescriptor.h>

RTProtocolDescriptor::Status
RTProtocol::receiveCheck( int signal, const RTObject_class * type ) const
{
    if( receiveTypeCheckEnabled() == 0 )
	// Checking disabled for this port: Assume all is well.
	return RTProtocolDescriptor::ok;

    const RTProtocolDescriptor * protocol = _info->protocol;

    if( protocol == (const RTProtocolDescriptor *)0 )
	// This should only happen with ELS proxies where neither end is local.
	return RTProtocolDescriptor::ok;

    return protocol->canReceive( signal, type );
}
