/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTMemoryUtil.h>
#include <RTinet.h>
#include <RTtcp.h>

extern "C" int RTinet_getname( int              sock,
			       RTinet_address * address,
			       RTinet_port    * port )
{
    sockaddr_in       addr;
    SocketAddressSize addr_len = sizeof( addr );

    //lint -save -e740
    while( INET_getsockname( sock,
			     (SocketAddress *)&addr,
			     &addr_len ) != 0 )
    //lint -restore
    {
#ifdef INET_EINTR
	if( INET_error( sock ) == INET_EINTR )
	    continue;
#endif

	return 0;
    }

    RTMemoryUtil::memcpy( address, &addr.sin_addr, (int)sizeof( *address ) );
    *port = ntohs( addr.sin_port );

    return 1;
}
