/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTActorRefProbe_h__
#define __RTActorRefProbe_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTActorProbe_h__
#include <RTActorProbe.h>
#endif

class RTActorRef;

class RTActorRefProbe : public RTActorProbe
{
public:
			    RTActorRefProbe( RTDebugger * debugger,
					     int          id,
					     const char * strPath );
    virtual                 ~RTActorRefProbe( void );

    virtual void            evtPresence ( int actorIndex,
					  int observerId,
					  int daemonId );
    virtual void            evtReference( int compIndex,  int observerId );

    virtual int             connectProbe   ( void );
    virtual int             disconnectProbe( RTActor * actor );

    RTS_INLINE RTActorRef * actorRef( void ) const;

private:
    RTActorRef            * getRefFromStrPath( void );

    RTActorRef            * _actorRef;

    // unavailable methods
    RTActorRefProbe( const RTActorRefProbe & );
    RTActorRefProbe & operator=( const RTActorRefProbe & );
}; //lint !e1712

#if RTS_INLINES
#include <RTActorRefProbe.inl>
#endif

#endif // __RTActorRefProbe_h__
