/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTQueue_inl__
#define __RTQueue_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTQueue_h__
#include <RTQueue.h>
#endif

RTS_INLINE RTQueue::RTQueue( void )
    : head( (Block *)0 )
    , tail( (Block *)0 )
{
}

RTS_INLINE int RTQueue::isEmpty( void ) const
{
    return head == (Block *)0;
}

RTS_INLINE RTQueue::Iterator::Iterator( void )
    : block( (Block *)0 )
    , index( 0 )
{
}

RTS_INLINE RTQueue::Iterator::Iterator( const RTQueue & queue )
    : block( queue.head )
    , index( 0 )
{
}

RTS_INLINE RTQueue::Iterator::~Iterator( void )
{
#ifdef _lint
    block = (Block *)0;
#endif
}

#endif // __RTQueue_inl__
