/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDiag.h>
#include <RTMain.h>

#if HAVE_INET
#include <RTtcp.h>
#endif

void RTMain::targetStartup( void )
{
#if HAVE_INET
    WORD    wVersionRequested = MAKEWORD( 1, 1 );
    WSADATA wsaData;
    int     err = WSAStartup( wVersionRequested, &wsaData );

    if( err != 0 )
    {
	/* Tell the user that we couldn't find a usable winsock.dll. */
	RTDiag::panic( "WSAStartup: Windows Sockets DLL is unusable." );
	//lint -unreachable
	return;
    }

    // Confirm that the Windows Sockets DLL supports 1.1.
    // Note that if the DLL supports versions greater than 1.1 in addition
    // to 1.1, it will still return 1.1 in wVersion since that is the version
    // we requested.

    if( LOBYTE( wsaData.wVersion ) != 1 || HIBYTE( wsaData.wVersion ) != 1 )
    {
	/* Tell the user that we couldn't find a usable winsock.dll. */
	(void)WSACleanup();
	RTDiag::panic( "Windows Sockets DLL is unusable" );
	//lint -unreachable
    }

    // The Windows Sockets DLL is acceptable. Proceed.
#endif
}
