/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDiagStream.h>
#include <RTNucleus.h>

extern "C"
{

#ifdef PLUS_MNT

extern HANDLE Con_Apl;

static inline void put_char( char ch )
{
    DWORD n;

    WriteConsole( Con_Apl, &ch, 1, &n, (void *)0 );
}

#else

#include <plus/uart.h>

static inline void put_char( char ch )
{
    UART_Put_Char( SMC1, ch );
}

#endif // PLUS_MNT

} // extern "C"

RTDiagStream & RTDiagStream::write( const char * string )
{
    char ch;

    while( (ch = *string++) != '\0' )
    {
	if( ch == '\n' )
	    put_char( '\r' );
	put_char( ch );
    }

    return *this;
}
