/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTtcp_h__
#define __RTtcp_h__ included

#include <sys/types.h>
#include <sys/time.h>
#include <errno.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <net/if.h>

typedef struct sockaddr SocketAddress;
typedef int             SocketAddressSize;

extern "C"
{
    int accept( int, SocketAddress *, int * );
    int bind( int, SocketAddress *, int );
    int close( int );
    int connect( int, SocketAddress *, int );
    int gethostname( char *, int );
    int getsockname( int, SocketAddress *, int * );
    int ioctl( int, int, int * );
    int listen( int, int );
    int recv( int, char *, int, int );
    int select( int, fd_set *, fd_set *, fd_set *, struct timeval * );
    int setsockopt( int, int, int, char *, int );
    int socket( int, int, int );
}

#define INET_HaveLength  0

#define INET_accept      accept
#define INET_bind        bind
#define INET_close       close
#define INET_connect     connect
#define INET_error( sd ) errno
#define INET_getsockname getsockname
#define INET_ioctl       ioctl
#define INET_listen      listen
#define INET_recv        recv
#define INET_recvfrom    recvfrom
#define INET_setsockopt  setsockopt
#define INET_socket      socket

#define INET_lookup( host ) \
			 gethostbyname( (char *)host )

#define INET_send( sock, data, size, flags ) \
			 send( (sock), (char *)(data), (size), (flags) )

#define INET_sendto( sock, data, size, flags, dst, dst_len ) \
			 sendto( (sock), (char *)(data), (size), (flags), \
				 (dst), (dst_len) )

#define INET_EALREADY    EALREADY
#define INET_EINPROGRESS EINPROGRESS
#define INET_EINTR       EINTR
#define INET_EISCONN     EISCONN
#define INET_EWOULDBLOCK EWOULDBLOCK

#endif // __RTtcp_h__
