/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifdef PRAGMA
#pragma implementation "RTMain.h"
#pragma implementation "RTMain.inl"
#pragma implementation "RTSystemDescriptor.h"
#endif

#include <RTMain.h>

#if USE_WINCE_RTCONSOLE
#include <RTDiag.h>
#include <RTSystemDescriptor.h>
#include <RTWinCE.h>
#endif

int RTMain::execute( void )
{
#if ! USE_WINCE_RTCONSOLE
    return mainLine();
#else
    HANDLE handle;
    DWORD  tid;

    if( (handle = CreateThread( (LPSECURITY_ATTRIBUTES)0,
				(DWORD)_system->mainStackSize,
				(LPTHREAD_START_ROUTINE)mainLine,
				(LPVOID)0,
				(DWORD)CREATE_SUSPENDED, &tid )) == (HANDLE)0 )
	RTDiag::panic( "execute(create)" );
#if TARGET_WINCE >= 300 && ! defined( _WIN32_WCE_EMULATION )
    else if( ! CeSetThreadPriority( handle, _system->mainPriority ) )
#else
    else if( ! SetThreadPriority( handle, THREAD_PRIORITY_NORMAL
					  + _system->mainPriority ) )
#endif
	RTDiag::panic( "RTThread(priority)" );
    else if( ResumeThread( handle ) != (DWORD)1 )
	RTDiag::panic( "execute(resume)" );
    else
	RTWinCE::soleInstance->mainThread = handle;

    return 0;
#endif // USE_WINCE_RTCONSOLE
}
